searchData={"items":[{"type":"module","title":"locus","doc":"The main API","ref":"locus.html"},{"type":"function","title":"locus.await_loader/1","doc":"Like await_loader/1 but with a default timeout of 30 seconds. DatabaseId must be an atom and refer to a database loader. Returns: {ok, LoadedVersion} when the database is ready to use. {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, {database_stopped, _}} if the database loader for DatabaseId stopped while we waited. {error, {timeout, [_]}} if all the load attempts performed before timing out have failed. See also: await_loader/2 .","ref":"locus.html#await_loader/1"},{"type":"function","title":"locus.await_loader/2","doc":"Blocks caller execution until either readiness is achieved or the default timeout is triggered. DatabaseId must be an atom and refer to a database loader. Timeout must be either a non-negative integer (milliseconds) or infinity . Returns: {ok, LoadedVersion} when the database is ready to use. {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, {database_stopped, _}} if the database loader for DatabaseId stopped while we waited. {error, {timeout, [_]}} if all the load attempts performed before timing out have failed. See also: await_loader/1 , await_loaders/2 .","ref":"locus.html#await_loader/2"},{"type":"function","title":"locus.await_loaders/2","doc":"Like await_loader/2 but it can concurrently await status from more than one database. DatabaseIds must be list of atom referring to database loaders. Timeout must be either a non-negative integer (milliseconds) or infinity . Returns: {ok, #{DatabaseId =&gt; LoadedVersion}} when all the database are ready to use. {error, {#{DatabaseId =&gt; ErrorReason}, _}} in case of errors. See also: await_loader/2 .","ref":"locus.html#await_loaders/2"},{"type":"function","title":"locus.check/1","doc":"Analyzes a loaded database for corruption or incompatibility. DatabaseId must be an atom and refer to a database loader. Returns: ok if the database is wholesome. {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, database_not_loaded} if the database hasn't yet been loaded. {validation_warnings, [CheckWarning, ...]} in case something smells within the database (check the definitions in locus_mmdb_check ) {validation_errors, [CheckError], [...]} in case of corruption or incompatibility (check the definitions in locus_mmdb_check )","ref":"locus.html#check/1"},{"type":"function","title":"locus.get_info/1","doc":"Returns the properties of a currently loaded database. DatabaseId must be an atom and refer to a database loader. Returns: {ok, database_info()} in case of success {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, database_not_loaded} if the database hasn't yet been loaded. See also: get_info/2 .","ref":"locus.html#get_info/1"},{"type":"function","title":"locus.get_info/2","doc":"Returns a specific property of a currently loaded database. DatabaseId must be an atom and refer to a database loader. Property must be either metadata , source or version . Returns: {ok, Value} in case of success {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, database_not_loaded} if the database hasn't yet been loaded. See also: get_info/1 .","ref":"locus.html#get_info/2"},{"type":"function","title":"locus.loader_child_spec/2","doc":"Like :loader_child_spec/2 but with default options DatabaseId must be an atom. LoadFrom must be either: a database_edition() tuple, or a DatabaseURL containing either a string or binary representation of a HTTP(s) URL or local path, or a {custom_fetcher, Module, Args} tuple, with Module implementing the locus_custom_fetcher behaviour Returns: A supervisor:child_spec() . See also: await_loader/1 , await_loader/2 , loader_child_spec/3 , start_loader/2 .","ref":"locus.html#loader_child_spec/2"},{"type":"function","title":"locus.loader_child_spec/3","doc":"Like :loader_child_spec/3 but with default child id DatabaseId must be an atom. LoadFrom must be either: a database_edition() tuple, or a DatabaseURL containing either a string or binary representation of a HTTP(s) URL or local path, or a {custom_fetcher, Module, Args} tuple, with Module implementing the locus_custom_fetcher behaviour Opts must be a list of locus_database:opt() values Returns: A supervisor:child_spec() . See also: await_loader/1 , await_loader/2 , loader_child_spec/2 , loader_child_spec/4 , start_loader/3 .","ref":"locus.html#loader_child_spec/3"},{"type":"function","title":"locus.loader_child_spec/4","doc":"Returns a supervisor child spec for a database loader under id DatabaseId with options Opts . DatabaseId must be an atom. LoadFrom must be either: a database_edition() tuple, or a DatabaseURL containing either a string or binary representation of a HTTP(s) URL or local path, or a {custom_fetcher, Module, Args} tuple, with Module implementing the locus_custom_fetcher behaviour Opts must be a list of locus_database:opt() values Returns: A supervisor:child_spec() . See also: await_loader/1 , await_loader/2 , loader_child_spec/3 , start_loader/3 .","ref":"locus.html#loader_child_spec/4"},{"type":"function","title":"locus.lookup/2","doc":"Looks-up info on IPv4 and IPv6 addresses. DatabaseId must be an atom and refer to a database loader. Address must be either an inet:ip_address() tuple, or a string/binary containing a valid representation of the address. Returns: {ok, Entry} in case of success not_found if no data was found for this Address . {error, invalid_address} if Address is not either a inet:ip_address() tuple or a valid textual representation of an IP address. {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, database_not_loaded} if the database hasn't yet been loaded. {error, ipv4_database} if Address represents an IPv6 address and the database only supports IPv4 addresses.","ref":"locus.html#lookup/2"},{"type":"function","title":"locus.start_loader/2","doc":"Like :start_loader/3 but with default options DatabaseId must be an atom. LoadFrom must be either: a database_edition() tuple, or a DatabaseURL containing either a string or binary representation of a HTTP(s) URL or local path, or a {custom_fetcher, Module, Args} tuple, with Module implementing the locus_custom_fetcher behaviour Returns: ok in case of success. {error, invalid_url} if the source is invalid. {error, already_started} if the loader under DatabaseId has already been started. See also: await_loader/1 , await_loader/2 , start_loader/3 .","ref":"locus.html#start_loader/2"},{"type":"function","title":"locus.start_loader/3","doc":"Starts a database loader under id DatabaseId with options Opts . DatabaseId must be an atom. LoadFrom must be either: a database_edition() tuple, or a DatabaseURL containing either a string or binary representation of a HTTP(s) URL or local path, or a {custom_fetcher, Module, Args} tuple, with Module implementing the locus_custom_fetcher behaviour Opts must be a list of locus_database:opt() values Returns: ok in case of success. {error, invalid_url} if the source is invalid. {error, already_started} if the loader under DatabaseId has already been started. See also: await_loader/1 , await_loader/2 , start_loader/2 .","ref":"locus.html#start_loader/3"},{"type":"function","title":"locus.stop_loader/1","doc":"Stops the database loader under id DatabaseId . DatabaseId must be an atom and refer to a database loader. Returns ok in case of success, {error, not_found} otherwise.","ref":"locus.html#stop_loader/1"},{"type":"type","title":"locus.custom_fetcher/0","doc":null,"ref":"locus.html#t:custom_fetcher/0"},{"type":"type","title":"locus.database_edition/0","doc":null,"ref":"locus.html#t:database_edition/0"},{"type":"type","title":"locus.database_entry/0","doc":null,"ref":"locus.html#t:database_entry/0"},{"type":"type","title":"locus.database_error/0","doc":null,"ref":"locus.html#t:database_error/0"},{"type":"type","title":"locus.database_info/0","doc":null,"ref":"locus.html#t:database_info/0"},{"type":"type","title":"locus.database_metadata/0","doc":null,"ref":"locus.html#t:database_metadata/0"},{"type":"type","title":"locus.database_source/0","doc":null,"ref":"locus.html#t:database_source/0"},{"type":"type","title":"locus.database_url/0","doc":null,"ref":"locus.html#t:database_url/0"},{"type":"type","title":"locus.database_version/0","doc":null,"ref":"locus.html#t:database_version/0"},{"type":"type","title":"locus.ip_address_prefix/0","doc":null,"ref":"locus.html#t:ip_address_prefix/0"},{"type":"type","title":"locus.legacy_maxmind_database_edition/0","doc":null,"ref":"locus.html#t:legacy_maxmind_database_edition/0"},{"type":"type","title":"locus.maxmind_database_edition/0","doc":null,"ref":"locus.html#t:maxmind_database_edition/0"},{"type":"behaviour","title":"locus_custom_fetcher","doc":"Callbacks for providing your own database fetcher","ref":"locus_custom_fetcher.html"},{"type":"callback","title":"locus_custom_fetcher.conditionally_fetch/2","doc":null,"ref":"locus_custom_fetcher.html#c:conditionally_fetch/2"},{"type":"callback","title":"locus_custom_fetcher.description/1","doc":null,"ref":"locus_custom_fetcher.html#c:description/1"},{"type":"callback","title":"locus_custom_fetcher.fetch/1","doc":null,"ref":"locus_custom_fetcher.html#c:fetch/1"},{"type":"type","title":"locus_custom_fetcher.description/0","doc":null,"ref":"locus_custom_fetcher.html#t:description/0"},{"type":"type","title":"locus_custom_fetcher.event/0","doc":null,"ref":"locus_custom_fetcher.html#t:event/0"},{"type":"type","title":"locus_custom_fetcher.event_load_attempt_dismissed/0","doc":null,"ref":"locus_custom_fetcher.html#t:event_load_attempt_dismissed/0"},{"type":"type","title":"locus_custom_fetcher.event_load_attempt_started/0","doc":null,"ref":"locus_custom_fetcher.html#t:event_load_attempt_started/0"},{"type":"type","title":"locus_custom_fetcher.msg/0","doc":null,"ref":"locus_custom_fetcher.html#t:msg/0"},{"type":"type","title":"locus_custom_fetcher.source/0","doc":null,"ref":"locus_custom_fetcher.html#t:source/0"},{"type":"opaque","title":"locus_custom_fetcher.state/0","doc":null,"ref":"locus_custom_fetcher.html#t:state/0"},{"type":"type","title":"locus_custom_fetcher.success/0","doc":null,"ref":"locus_custom_fetcher.html#t:success/0"},{"type":"type","title":"locus_custom_fetcher.successful_fetch_metadata/0","doc":null,"ref":"locus_custom_fetcher.html#t:successful_fetch_metadata/0"},{"type":"module","title":"locus_database","doc":"Launches locus_database_loader and later shares the unpacked database, as well as any updates to it, through persistent_term .","ref":"locus_database.html"},{"type":"function","title":"locus_database.version/1","doc":"Returns the database version based on its build epoch (UNIX timestamp)","ref":"locus_database.html#version/1"},{"type":"type","title":"locus_database.database_opt/0","doc":null,"ref":"locus_database.html#t:database_opt/0"},{"type":"type","title":"locus_database.event/0","doc":null,"ref":"locus_database.html#t:event/0"},{"type":"type","title":"locus_database.event_load_attempt_finished/0","doc":null,"ref":"locus_database.html#t:event_load_attempt_finished/0"},{"type":"type","title":"locus_database.monitor/0","doc":null,"ref":"locus_database.html#t:monitor/0"},{"type":"type","title":"locus_database.opt/0","doc":null,"ref":"locus_database.html#t:opt/0"},{"type":"type","title":"locus_database.origin/0","doc":null,"ref":"locus_database.html#t:origin/0"},{"type":"opaque","title":"locus_database.state/0","doc":null,"ref":"locus_database.html#t:state/0"},{"type":"type","title":"locus_database.static_child_spec/0","doc":null,"ref":"locus_database.html#t:static_child_spec/0"},{"type":"behaviour","title":"locus_event_subscriber","doc":"Callback for implementing your own locus_database event subscribers","ref":"locus_event_subscriber.html"},{"type":"callback","title":"locus_event_subscriber.report/2","doc":null,"ref":"locus_event_subscriber.html#c:report/2"},{"type":"type","title":"locus_event_subscriber.event/0","doc":null,"ref":"locus_event_subscriber.html#t:event/0"},{"type":"module","title":"locus_filesystem_load","doc":"Loads a file from the filesystem without blocking the caller","ref":"locus_filesystem_load.html"},{"type":"type","title":"locus_filesystem_load.event/0","doc":null,"ref":"locus_filesystem_load.html#t:event/0"},{"type":"type","title":"locus_filesystem_load.event_load_attempt_dismissed/0","doc":null,"ref":"locus_filesystem_load.html#t:event_load_attempt_dismissed/0"},{"type":"type","title":"locus_filesystem_load.event_load_attempt_started/0","doc":null,"ref":"locus_filesystem_load.html#t:event_load_attempt_started/0"},{"type":"type","title":"locus_filesystem_load.msg/0","doc":null,"ref":"locus_filesystem_load.html#t:msg/0"},{"type":"type","title":"locus_filesystem_load.path/0","doc":null,"ref":"locus_filesystem_load.html#t:path/0"},{"type":"type","title":"locus_filesystem_load.source/0","doc":null,"ref":"locus_filesystem_load.html#t:source/0"},{"type":"opaque","title":"locus_filesystem_load.state/0","doc":null,"ref":"locus_filesystem_load.html#t:state/0"},{"type":"type","title":"locus_filesystem_load.success/0","doc":null,"ref":"locus_filesystem_load.html#t:success/0"},{"type":"module","title":"locus_filesystem_store","doc":"Stores a file in the filesystem without blocking the caller","ref":"locus_filesystem_store.html"},{"type":"type","title":"locus_filesystem_store.msg/0","doc":null,"ref":"locus_filesystem_store.html#t:msg/0"},{"type":"type","title":"locus_filesystem_store.path/0","doc":null,"ref":"locus_filesystem_store.html#t:path/0"},{"type":"opaque","title":"locus_filesystem_store.state/0","doc":null,"ref":"locus_filesystem_store.html#t:state/0"},{"type":"module","title":"locus_http_download","doc":"Downloads a file using HTTP(S) without blocking the caller","ref":"locus_http_download.html"},{"type":"type","title":"locus_http_download.body/0","doc":null,"ref":"locus_http_download.html#t:body/0"},{"type":"type","title":"locus_http_download.event/0","doc":null,"ref":"locus_http_download.html#t:event/0"},{"type":"type","title":"locus_http_download.event_download_dismissed/0","doc":null,"ref":"locus_http_download.html#t:event_download_dismissed/0"},{"type":"type","title":"locus_http_download.event_download_failed_to_start/0","doc":null,"ref":"locus_http_download.html#t:event_download_failed_to_start/0"},{"type":"type","title":"locus_http_download.event_download_finished/0","doc":null,"ref":"locus_http_download.html#t:event_download_finished/0"},{"type":"type","title":"locus_http_download.event_download_redirected/0","doc":null,"ref":"locus_http_download.html#t:event_download_redirected/0"},{"type":"type","title":"locus_http_download.event_download_started/0","doc":null,"ref":"locus_http_download.html#t:event_download_started/0"},{"type":"type","title":"locus_http_download.event_request_sent/0","doc":null,"ref":"locus_http_download.html#t:event_request_sent/0"},{"type":"type","title":"locus_http_download.full_http_response/0","doc":null,"ref":"locus_http_download.html#t:full_http_response/0"},{"type":"type","title":"locus_http_download.headers/0","doc":null,"ref":"locus_http_download.html#t:headers/0"},{"type":"type","title":"locus_http_download.msg/0","doc":null,"ref":"locus_http_download.html#t:msg/0"},{"type":"type","title":"locus_http_download.opt/0","doc":null,"ref":"locus_http_download.html#t:opt/0"},{"type":"type","title":"locus_http_download.reason_for_download_failing_to_start/0","doc":null,"ref":"locus_http_download.html#t:reason_for_download_failing_to_start/0"},{"type":"type","title":"locus_http_download.redirection/0","doc":null,"ref":"locus_http_download.html#t:redirection/0"},{"type":"type","title":"locus_http_download.response_status/0","doc":null,"ref":"locus_http_download.html#t:response_status/0"},{"type":"opaque","title":"locus_http_download.state/0","doc":null,"ref":"locus_http_download.html#t:state/0"},{"type":"type","title":"locus_http_download.success/0","doc":null,"ref":"locus_http_download.html#t:success/0"},{"type":"type","title":"locus_http_download.url/0","doc":null,"ref":"locus_http_download.html#t:url/0"},{"type":"module","title":"locus_loader","doc":"Loads and unpacks databases while managing any associated assets (e.g. reading from and writing to cache)","ref":"locus_loader.html"},{"type":"type","title":"locus_loader.blob_format/0","doc":null,"ref":"locus_loader.html#t:blob_format/0"},{"type":"type","title":"locus_loader.cacher_msg/0","doc":null,"ref":"locus_loader.html#t:cacher_msg/0"},{"type":"type","title":"locus_loader.error_retry_behaviour/0","doc":null,"ref":"locus_loader.html#t:error_retry_behaviour/0"},{"type":"type","title":"locus_loader.event/0","doc":null,"ref":"locus_loader.html#t:event/0"},{"type":"type","title":"locus_loader.event_cache_attempt_finished/0","doc":null,"ref":"locus_loader.html#t:event_cache_attempt_finished/0"},{"type":"type","title":"locus_loader.exponential_backoff_params/0","doc":null,"ref":"locus_loader.html#t:exponential_backoff_params/0"},{"type":"type","title":"locus_loader.fetcher_msg/0","doc":null,"ref":"locus_loader.html#t:fetcher_msg/0"},{"type":"type","title":"locus_loader.fetcher_opt/0","doc":null,"ref":"locus_loader.html#t:fetcher_opt/0"},{"type":"type","title":"locus_loader.fetcher_success/0","doc":null,"ref":"locus_loader.html#t:fetcher_success/0"},{"type":"type","title":"locus_loader.loader_opt/0","doc":null,"ref":"locus_loader.html#t:loader_opt/0"},{"type":"type","title":"locus_loader.maxmind_origin_params/0","doc":null,"ref":"locus_loader.html#t:maxmind_origin_params/0"},{"type":"type","title":"locus_loader.milliseconds_interval/0","doc":null,"ref":"locus_loader.html#t:milliseconds_interval/0"},{"type":"type","title":"locus_loader.msg/0","doc":null,"ref":"locus_loader.html#t:msg/0"},{"type":"type","title":"locus_loader.opt/0","doc":null,"ref":"locus_loader.html#t:opt/0"},{"type":"type","title":"locus_loader.origin/0","doc":null,"ref":"locus_loader.html#t:origin/0"},{"type":"type","title":"locus_loader.provider_source/0","doc":null,"ref":"locus_loader.html#t:provider_source/0"},{"type":"type","title":"locus_loader.settings/0","doc":null,"ref":"locus_loader.html#t:settings/0"},{"type":"type","title":"locus_loader.source/0","doc":null,"ref":"locus_loader.html#t:source/0"},{"type":"opaque","title":"locus_loader.state/0","doc":null,"ref":"locus_loader.html#t:state/0"},{"type":"type","title":"locus_loader.uniformly_distributed_update_period/0","doc":null,"ref":"locus_loader.html#t:uniformly_distributed_update_period/0"},{"type":"type","title":"locus_loader.update_period/0","doc":null,"ref":"locus_loader.html#t:update_period/0"},{"type":"module","title":"locus_logger","doc":"Logging of locus_database events; can be adjusted in app config as well as at run time.","ref":"locus_logger.html"},{"type":"function","title":"locus_logger.set_loglevel/1","doc":"Changes the logging verbosity in runtime Level must be either debug , info , warning , error or none .","ref":"locus_logger.html#set_loglevel/1"},{"type":"module","title":"locus_maxmind_download","doc":"Downloads an unpacked database edition from MaxMind, as well as its checksum (which it then verifies), without blocking the caller.","ref":"locus_maxmind_download.html"},{"type":"type","title":"locus_maxmind_download.event/0","doc":null,"ref":"locus_maxmind_download.html#t:event/0"},{"type":"type","title":"locus_maxmind_download.msg/0","doc":null,"ref":"locus_maxmind_download.html#t:msg/0"},{"type":"type","title":"locus_maxmind_download.opt/0","doc":null,"ref":"locus_maxmind_download.html#t:opt/0"},{"type":"opaque","title":"locus_maxmind_download.state/0","doc":null,"ref":"locus_maxmind_download.html#t:state/0"},{"type":"type","title":"locus_maxmind_download.success/0","doc":null,"ref":"locus_maxmind_download.html#t:success/0"},{"type":"module","title":"locus_mmdb","doc":"API for working with MMDB","ref":"locus_mmdb.html"},{"type":"function","title":"locus_mmdb.lookup_address/2","doc":"Looks up for an entry matching Address within Database","ref":"locus_mmdb.html#lookup_address/2"},{"type":"function","title":"locus_mmdb.unpack_database/1","doc":"Unpacks an EncodedDatabase binary into a ready-to-use Database .","ref":"locus_mmdb.html#unpack_database/1"},{"type":"function","title":"locus_mmdb.unpack_tree_data_and_data_section/2","doc":"Unpacks a single TreeAndDataSection binary into separate TreeData and DataSection binaries, leveraging Metadata to calculate the size of TreeData . You can then use TreeData on your own or leverage it to instantiate a new locus_mmdb_tree:t() , through locus_mmdb_tree:new/5 . As for DataSection , you can also either use it on your own or pass it to the API defined under locus_mmdb_data_codec . For how to obtain Metadata and TreeAndDataSection in the first place, see locus_mmdb_metadata:parse_and_validate/1 .","ref":"locus_mmdb.html#unpack_tree_data_and_data_section/2"},{"type":"type","title":"locus_mmdb.database/0","doc":null,"ref":"locus_mmdb.html#t:database/0"},{"type":"type","title":"locus_mmdb.failed_to_unpack_tree_data_and_data_section/0","doc":null,"ref":"locus_mmdb.html#t:failed_to_unpack_tree_data_and_data_section/0"},{"type":"type","title":"locus_mmdb.unpack_error/0","doc":null,"ref":"locus_mmdb.html#t:unpack_error/0"},{"type":"module","title":"locus_mmdb_check","doc":"API for working with MMDB - wholesomeness check","ref":"locus_mmdb_check.html"},{"type":"function","title":"locus_mmdb_check.run/1","doc":"Checks for errors and quirks within Database","ref":"locus_mmdb_check.html#run/1"},{"type":"type","title":"locus_mmdb_check.bad_chunk_in_data_section/0","doc":null,"ref":"locus_mmdb_check.html#t:bad_chunk_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.bad_data_index_in_tree/0","doc":null,"ref":"locus_mmdb_check.html#t:bad_data_index_in_tree/0"},{"type":"type","title":"locus_mmdb_check.bad_node_index_in_tree/0","doc":null,"ref":"locus_mmdb_check.html#t:bad_node_index_in_tree/0"},{"type":"type","title":"locus_mmdb_check.error/0","doc":null,"ref":"locus_mmdb_check.html#t:error/0"},{"type":"type","title":"locus_mmdb_check.excessively_long_path_in_tree/0","doc":null,"ref":"locus_mmdb_check.html#t:excessively_long_path_in_tree/0"},{"type":"type","title":"locus_mmdb_check.invalid_position_in_data_section/0","doc":null,"ref":"locus_mmdb_check.html#t:invalid_position_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.invalid_utf8_string_in_data_section/0","doc":null,"ref":"locus_mmdb_check.html#t:invalid_utf8_string_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.loop_in_data_section/0","doc":null,"ref":"locus_mmdb_check.html#t:loop_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.map_key_of_wrong_type_in_data_section/0","doc":null,"ref":"locus_mmdb_check.html#t:map_key_of_wrong_type_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.unprintable_utf8_string_in_data_section/0","doc":null,"ref":"locus_mmdb_check.html#t:unprintable_utf8_string_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.warning/0","doc":null,"ref":"locus_mmdb_check.html#t:warning/0"},{"type":"module","title":"locus_mmdb_data","doc":"API for working with MMDB - data representation","ref":"locus_mmdb_data.html"},{"type":"type","title":"locus_mmdb_data.array/0","doc":null,"ref":"locus_mmdb_data.html#t:array/0"},{"type":"type","title":"locus_mmdb_data.boolean_/0","doc":null,"ref":"locus_mmdb_data.html#t:boolean_/0"},{"type":"type","title":"locus_mmdb_data.bytes/0","doc":null,"ref":"locus_mmdb_data.html#t:bytes/0"},{"type":"type","title":"locus_mmdb_data.double/0","doc":null,"ref":"locus_mmdb_data.html#t:double/0"},{"type":"type","title":"locus_mmdb_data.float_/0","doc":null,"ref":"locus_mmdb_data.html#t:float_/0"},{"type":"type","title":"locus_mmdb_data.int32/0","doc":null,"ref":"locus_mmdb_data.html#t:int32/0"},{"type":"type","title":"locus_mmdb_data.map_/0","doc":null,"ref":"locus_mmdb_data.html#t:map_/0"},{"type":"type","title":"locus_mmdb_data.uint16/0","doc":null,"ref":"locus_mmdb_data.html#t:uint16/0"},{"type":"type","title":"locus_mmdb_data.uint32/0","doc":null,"ref":"locus_mmdb_data.html#t:uint32/0"},{"type":"type","title":"locus_mmdb_data.uint64/0","doc":null,"ref":"locus_mmdb_data.html#t:uint64/0"},{"type":"type","title":"locus_mmdb_data.uint128/0","doc":null,"ref":"locus_mmdb_data.html#t:uint128/0"},{"type":"type","title":"locus_mmdb_data.utf8_string/0","doc":null,"ref":"locus_mmdb_data.html#t:utf8_string/0"},{"type":"type","title":"locus_mmdb_data.value/0","doc":null,"ref":"locus_mmdb_data.html#t:value/0"},{"type":"module","title":"locus_mmdb_data_codec","doc":"API for working with MMDB - data codec","ref":"locus_mmdb_data_codec.html"},{"type":"function","title":"locus_mmdb_data_codec.parse_on_index/3","doc":"Attempts to parse either the Value or RawValue (depending on the Raw flag) at Index in DataSection . Will crash upon invalid/unrecognized data, invalid pointers or cyclic pointer chasing (i.e. loops.)","ref":"locus_mmdb_data_codec.html#parse_on_index/3"},{"type":"type","title":"locus_mmdb_data_codec.index/0","doc":null,"ref":"locus_mmdb_data_codec.html#t:index/0"},{"type":"module","title":"locus_mmdb_data_raw","doc":"API for working with MMDB - raw data representation (it preserves the original type for when it's necessary to distinguish between e.g. {uint32, 0} and {uint16, 0} , which locus_mmdb_data does not allow for.)","ref":"locus_mmdb_data_raw.html"},{"type":"type","title":"locus_mmdb_data_raw.array/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:array/0"},{"type":"type","title":"locus_mmdb_data_raw.boolean_/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:boolean_/0"},{"type":"type","title":"locus_mmdb_data_raw.bytes/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:bytes/0"},{"type":"type","title":"locus_mmdb_data_raw.double/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:double/0"},{"type":"type","title":"locus_mmdb_data_raw.float_/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:float_/0"},{"type":"type","title":"locus_mmdb_data_raw.int32/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:int32/0"},{"type":"type","title":"locus_mmdb_data_raw.map_/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:map_/0"},{"type":"type","title":"locus_mmdb_data_raw.uint16/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:uint16/0"},{"type":"type","title":"locus_mmdb_data_raw.uint32/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:uint32/0"},{"type":"type","title":"locus_mmdb_data_raw.uint64/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:uint64/0"},{"type":"type","title":"locus_mmdb_data_raw.uint128/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:uint128/0"},{"type":"type","title":"locus_mmdb_data_raw.utf8_string/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:utf8_string/0"},{"type":"type","title":"locus_mmdb_data_raw.value/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:value/0"},{"type":"type","title":"locus_mmdb_data_raw.value_tag/0","doc":null,"ref":"locus_mmdb_data_raw.html#t:value_tag/0"},{"type":"module","title":"locus_mmdb_metadata","doc":"API for working with MMDB - metadata","ref":"locus_mmdb_metadata.html"},{"type":"function","title":"locus_mmdb_metadata.parse_and_validate/1","doc":"Parses and validates Metadata out of EncodedDatabase To proceed further with TreeAndDataSection , see locus_mmdb:unpack_tree_data_and_data_section/2 .","ref":"locus_mmdb_metadata.html#parse_and_validate/1"},{"type":"type","title":"locus_mmdb_metadata.binary_format_version/0","doc":"{Major, Minor}","ref":"locus_mmdb_metadata.html#t:binary_format_version/0"},{"type":"type","title":"locus_mmdb_metadata.parse_or_validation_error/0","doc":null,"ref":"locus_mmdb_metadata.html#t:parse_or_validation_error/0"},{"type":"type","title":"locus_mmdb_metadata.t/0","doc":null,"ref":"locus_mmdb_metadata.html#t:t/0"},{"type":"module","title":"locus_mmdb_tree","doc":"API for working with MMDB - tree section","ref":"locus_mmdb_tree.html"},{"type":"function","title":"locus_mmdb_tree.lookup/2","doc":"Looks up for a DataIndex for Address within Tree","ref":"locus_mmdb_tree.html#lookup/2"},{"type":"function","title":"locus_mmdb_tree.new/5","doc":"Instantiates a new Tree out of TreeData , a few metadata properties and DataSectionSize","ref":"locus_mmdb_tree.html#new/5"},{"type":"type","title":"locus_mmdb_tree.bad_tree_error/0","doc":null,"ref":"locus_mmdb_tree.html#t:bad_tree_error/0"},{"type":"type","title":"locus_mmdb_tree.index/0","doc":null,"ref":"locus_mmdb_tree.html#t:index/0"},{"type":"type","title":"locus_mmdb_tree.ip4_address_prefix/0","doc":null,"ref":"locus_mmdb_tree.html#t:ip4_address_prefix/0"},{"type":"type","title":"locus_mmdb_tree.ip6_address_prefix/0","doc":null,"ref":"locus_mmdb_tree.html#t:ip6_address_prefix/0"},{"type":"type","title":"locus_mmdb_tree.ip_address_prefix/0","doc":null,"ref":"locus_mmdb_tree.html#t:ip_address_prefix/0"},{"type":"opaque","title":"locus_mmdb_tree.t/0","doc":null,"ref":"locus_mmdb_tree.html#t:t/0"},{"type":"extras","title":"locus","doc":"# locus\n\n[![Hex downloads](https://img.shields.io/hexpm/dt/locus.svg)](https://hex.pm/packages/locus)\n[![License](https://img.shields.io/hexpm/l/locus.svg)](https://github.com/g-andrade/locus/blob/master/LICENSE)\n[![Erlang Versions](https://img.shields.io/badge/Erlang%2FOTP-22%20to%2027-blue)](https://www.erlang.org)\n[![CI status](https://github.com/g-andrade/locus/actions/workflows/ci.yml/badge.svg)](https://github.com/g-andrade/locus/actions/workflows/ci.yml)\n[![Latest version](https://img.shields.io/hexpm/v/locus.svg?style=flat)](https://hex.pm/packages/locus)\n[![API reference](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/locus/)\n[![Last commit](https://img.shields.io/github/last-commit/g-andrade/locus.svg)](https://github.com/g-andrade/locus/commits/master)\n\n`locus` is library for Erlang/OTP and Elixir that allows you to pinpoint\nthe country, city or ASN of IP addresses using [MaxMind\nGeoIP2](https://dev.maxmind.com/geoip/geoip2/geolite2/) and [other\nproviders](#alternative-providers).\n\nThe databases will be loaded on-demand and, when retrieved from the\nnetwork, cached on the filesystem and updated automatically.\n\n> ⚠️ For instructions on how to upgrade to 2.x, check\n> [`MIGRATION.md`](https://github.com/g-andrade/locus/blob/master/MIGRATION.md)","ref":"readme.html"},{"type":"extras","title":"Usage - locus","doc":"##","ref":"readme.html#usage"},{"type":"extras","title":"1\\. Configure your license key - locus","doc":"*Skip this step if you're not loading databases directly from\nMaxMind.*\n\nGet a free [license key](https://www.maxmind.com/en/geolite2/signup)\nfrom MaxMind if you haven't one already. Once logged in, you'll find the\npage to generate it on the left menu, under \"Manage License Keys\".\n\nThen clone the repository, run `make shell` and declare your key:\n\n``` erlang\napplication:set_env(locus, license_key, \"YOUR_LICENSE_KEY\").\n```\n\nIf you're using Elixir, add locus as a dependency to your mix project:\n\n```elixir\ndefp deps do\n    [\n      ...\n      {:locus, \"~> 2.3\"}\n    ]\n  end\n```\n\nThen, configure your license key in `config.exs`:\n\n```elixir\nconfig :locus,\n  license_key:  \n```\n\n##","ref":"readme.html#1-configure-your-license-key"},{"type":"extras","title":"2\\. Start the database loader - locus","doc":"``` erlang\nok = locus:start_loader(country, {maxmind, \"GeoLite2-Country\"}).\n% You can also use:\n% * an HTTP(S) URL,\n% * or a local path, e.g. \"/usr/share/GeoIP/GeoLite2-City.mmdb\"\n% * or a {custom_fetcher, Module, Args} tuple, with Module\n%   implementing the locus_custom_fetcher behaviour.\n```\n\nOr, in Elixir, start the database loaders that you'll be using in `application.ex`:\n\n```elixir\n  def start(_type, _args) do\n    # :locus.start_loader(:asn, {:maxmind, \"GeoLite2-ASN\"})\n    # :locus.start_loader(:country, {:maxmind, \"GeoLite2-Country\"})\n    :locus.start_loader(:city, {:maxmind, \"GeoLite2-City\"})\n\n    ...\n```\n\n##","ref":"readme.html#2-start-the-database-loader"},{"type":"extras","title":"3\\. Wait for the database to load (optional) - locus","doc":"``` erlang\n{ok, _DatabaseVersion} = locus:await_loader(country). % or `{error, Reason}'\n```\n\n##","ref":"readme.html#3-wait-for-the-database-to-load-optional"},{"type":"extras","title":"4\\. Look up IP addresses - locus","doc":"``` erlang\n\n% > locus:lookup(country, \"93.184.216.34\").\n% > locus:lookup(country, \"2606:2800:220:1:248:1893:25c8:1946\").\n\n% * '{ok, Entry}' in case of success;\n% * 'not_found' if no entry was found\n% * '{error, _}' if something bad happened\n\n{ok,#{<<\"continent\">> =>\n          #{<<\"code\">> => <<\"NA\">>,\n            <<\"geoname_id\">> => 6255149,\n            <<\"names\">> =>\n                #{<<\"de\">> => <<\"Nordamerika\">>,\n                  <<\"en\">> => <<\"North America\">>,\n                  <<\"es\">> => <<\"Norteamérica\"/utf8>>,\n                  <<\"fr\">> => <<\"Amérique du Nord\"/utf8>>,\n                  <<\"ja\">> => <<\"北アメリカ\"/utf8>>,\n                  <<\"pt-BR\">> => <<\"América do Norte\"/utf8>>,\n                  <<\"ru\">> => <<\"Северная Америка\"/utf8>>,\n                  <<\"zh-CN\">> => <<\"北美洲\"/utf8>>}},\n      <<\"country\">> =>\n          #{<<\"geoname_id\">> => 6252001,\n            <<\"iso_code\">> => <<\"US\">>,\n            <<\"names\">> =>\n                #{<<\"de\">> => <<\"USA\">>,\n                  <<\"en\">> => <<\"United States\">>,\n                  <<\"es\">> => <<\"Estados Unidos\">>,\n                  <<\"fr\">> => <<\"États-Unis\"/utf8>>,\n                  <<\"ja\">> => <<\"アメリカ合衆国\"/utf8>>,\n                  <<\"pt-BR\">> => <<\"Estados Unidos\">>,\n                  <<\"ru\">> => <<\"США\"/utf8>>,\n                  <<\"zh-CN\">> => <<\"美国\"/utf8>>}},\n      <<\"registered_country\">> =>\n          #{<<\"geoname_id\">> => 6252001,\n            <<\"iso_code\">> => <<\"US\">>,\n            <<\"names\">> =>\n                #{<<\"de\">> => <<\"USA\">>,\n                  <<\"en\">> => <<\"United States\">>,\n                  <<\"es\">> => <<\"Estados Unidos\">>,\n                  <<\"fr\">> => <<\"États-Unis\"/utf8>>,\n                  <<\"ja\">> => <<\"アメリカ合衆国\"/utf8>>,\n                  <<\"pt-BR\">> => <<\"Estados Unidos\">>,\n                  <<\"ru\">> => <<\"США\"/utf8>>,\n                  <<\"zh-CN\">> => <<\"美国\"/utf8>>}}}}\n```\n\nOr, in Elixir, call the erlang library from your Elixir application:\n\n```elixir\niex> :locus.lookup(:city, \"93.184.216.34\")\n{:ok,\n %{\n   \"city\" => %{\"geoname_id\" => 4945936, \"names\" => %{\"en\" => \"Norwell\"}},\n   ...\n }}\n```","ref":"readme.html#4-look-up-ip-addresses"},{"type":"extras","title":"Documentation - locus","doc":"1.  [Supported File Formats](#supported-file-formats)\n2.  [Database Types and Loading](#database-types-and-loading)\n3.  [Database Validation](#database-validation)\n4.  [Remote sources: Downloading and\n    Updating](#remote-sources-downloading-and-updating)\n5.  [Remote sources: Caching](#remote-sources-caching)\n6.  [Local sources: Loading and\n    Updating](#local-sources-loading-and-updating)\n7.  [Logging](#logging)\n8.  [Event Subscriptions](#event-subscriptions)\n9.  [API Reference](#api-reference)\n10. [Tested Setup](#tested-setup)\n11. [License](#license)\n12. [Alternative Providers](#alternative-providers)\n13. [Alternative Libraries (Erlang)](#alternative-libraries-erlang)\n14. [Alternative Libraries (Elixir)](#alternative-libraries-elixir)\n\n#","ref":"readme.html#documentation"},{"type":"extras","title":"Supported File Formats - locus","doc":"- gzip-compressed tarballs (`.tar.gz`, `.tgz`)\n  - plain tarballs (`.tar`)\n  - MMDB files (`.mmdb`)\n  - gzip-compressed MMDB files (`.mmdb.gz`)\n\nFor tarball files, the first file to be found within it with an `.mmdb`\nextension is the one that's chosen for loading.\n\nThe implementation of [MaxMind DB\nformat](https://maxmind.github.io/MaxMind-DB/) is complete except for\nthe [`data cache\ncontainer`](https://maxmind.github.io/MaxMind-DB/#data-cache-container---12)\ndata type.\n\n#","ref":"readme.html#supported-file-formats"},{"type":"extras","title":"Database Types and Loading - locus","doc":"- The free GeoLite2 [Country, City and ASN\n    databases](https://dev.maxmind.com/geoip/geoip2/geolite2/) were all\n    successfully tested; presumably `locus` can deal with [any MMDB\n    database](#alternative-providers) that maps IP address prefixes to\n    arbitrary data\n  - The databases are loaded into memory (mostly) as is; reference\n    counted binaries are shared with the application callers using\n    [`persistent_term`](https://erlang.org/doc/man/persistent_term.html),\n    and the original binary search tree is used to lookup addresses. The\n    data for each entry is decoded on the fly upon successful lookups.\n\n#","ref":"readme.html#database-types-and-loading"},{"type":"extras","title":"Database Validation - locus","doc":"Databases, local or remote, can have their compatibility validated\nthrough the `locus:check/1` function after they've been loaded (see\n[function reference](#api-reference).)\n\nAlternatively, they can also be checked from the command line by use of\nthe `locus` CLI utility:\n\n1.  Run `make cli` to build the script, named `locus`, which will be\n    deployed to the current directory.\n\n2.  Check the database:\n\n    ``` shell\n    ./locus check GeoLite2-City.mmdb\n    # Loading database from \"GeoLite2-City.mmdb\"...\n    # Database version {{2019,11,6},{11,58,0}} successfully loaded\n    # Checking database for flaws...\n    # Database is wholesome.\n    ```\n\nThe script will exit with code 1 in case of failure, and 0 otherwise.\n\nWarnings can produce failure through the `--warnings-as-errors` flag.\n\nRun `./locus check --help` for a description of supported options and\narguments.\n\n#","ref":"readme.html#database-validation"},{"type":"extras","title":"Remote sources: Downloading and Updating - locus","doc":"- The downloaded database files, when compressed, are inflated in\n    memory\n  - For MaxMind and HTTP downloads, the `last-modified` response header,\n    if present, is used to condition subsequent download attempts (using\n    `if-modified-since` request headers) in order to save bandwidth\n  - The downloaded databases are cached on the filesystem in order to\n    more quickly achieve readiness on future launches of the database\n    loader\n  - Database download attempts are retried upon error according to an\n    exponential backoff policy - quickly at first (every few seconds)\n    but gradually slowing down to every 15 minutes. Successful and\n    dismissed download attempts will be checked for update after 6\n    hours. Both of these behaviours can be tweaked through the\n    `error_retries` and `update_period` loader settings (see [function\n    reference](#api-reference).)\n  - When downloading from a MaxMind edition or an HTTP URL, the remote\n    certificate will be authenticated against [a list of known\n    Certification\n    Authorities](https://hexdocs.pm/tls_certificate_check/) and\n    connection negotiation will fail in case of an expired certificate,\n    mismatched hostname, self-signed certificate or unknown\n    certification authority. These checks can be disabled by specifying\n    the `insecure` loader option.\n\n#","ref":"readme.html#remote-sources-downloading-and-updating"},{"type":"extras","title":"Remote sources: Caching - locus","doc":"- Caching is a best effort; the system falls back to relying\n    exclusively on the network if needed\n  - By default a caching directory named `locus_erlang` is created under the\n    ['user\\_cache'\n    basedir](http://erlang.org/doc/man/filename.html#basedir-3)\n  - A cached database is named after either:\n      - the MaxMind database edition name (when explicitly downloading\n        from MaxMind), or\n      - the SHA256 hash of the HTTP(S) URL, or\n      - for `{custom_fetcher, Module, Args}` sources, a filesystem-safe\n        version of `Module`'s name concatenated with the 32-bit\n        [`erlang:phash2/2`](https://erlang.org/doc/man/erlang.html#phash2-2)\n        value of the opaque database source as returned by the\n        callbacks.\n  - Modification time of the databases is retrieved from either:\n      - the `last-modified` response header (when present, for MaxMind\n        and HTTP(S) sources)\n      - the `modified_on` metadata property for successful\n        `locus_custom_fetcher` `:fetch/1` and `:conditionally_fetch/2`\n        callbacks (for databases loaded with `locus_custom_fetcher`)\n  - Caching can be disabled by specifying the `no_cache` option when\n    running `:start_loader`\n  - The cache database location can be customised by providing\n    `{database_cache_file, FilePath}` option for `locus_loader`\n    (`FilePath` must have a \".mmdb.gz\" extension)\n\n#","ref":"readme.html#remote-sources-caching"},{"type":"extras","title":"Local sources: Loading and Updating - locus","doc":"- The loaded database files, when compressed, are inflated in memory\n  - The database modification timestamp is used to condition subsequent\n    load attempts in order to lower I/O activity\n  - Database load attempts are retried upon error according to an\n    exponential backoff policy - quickly at first (every few seconds)\n    but gradually slowing down to every 30 seconds. Successful and\n    dismissed load attempts will be checked for update after 30 seconds.\n    Both of these behaviours can be tweaked through the `error_retries`\n    and `update_period` loader settings (see [function\n    reference](#api-reference).)\n\n#","ref":"readme.html#local-sources-loading-and-updating"},{"type":"extras","title":"Logging - locus","doc":"- Five logging levels are supported: `debug`, `info`, `warning`,\n    `error` and `none`\n  - The chosen backend is\n    [logger](http://erlang.org/doc/man/logger.html) *if*\n    [lager](https://github.com/erlang-lager/lager/) is either missing or\n    it hasn't\n    [removed](https://github.com/erlang-lager/lager/issues/492)\n    `logger`'s default handler.\n  - The default log level is `error`; it can be changed in the\n    application's `env` config\n  - To tweak the log level in runtime, use `locus_logger:set_loglevel/1`\n\n#","ref":"readme.html#logging"},{"type":"extras","title":"Event Subscriptions - locus","doc":"- Any number of event subscribers can be attached to a database loader\n    by specifying the `{event_subscriber, Subscriber}` option when\n    starting the database\n  - A `Subscriber` can be either a module implementing the\n    `locus_event_subscriber` behaviour or an arbitrary `pid()`\n  - The format and content of reported events can be consulted in detail\n    on the `locus_event_subscriber` module documentation; most key steps\n    in the loader pipeline are reported (download started, download\n    succeeded, download failed, caching succeeded, loading failed, etc.)\n\n#","ref":"readme.html#event-subscriptions"},{"type":"extras","title":"API Reference - locus","doc":"The API reference can be found on [HexDocs](https://hexdocs.pm/locus/).\n\n#","ref":"readme.html#api-reference"},{"type":"extras","title":"Tested setup - locus","doc":"- Erlang/OTP 22 or newer\n  - rebar3\n\n#","ref":"readme.html#tested-setup"},{"type":"extras","title":"License - locus","doc":"MIT License\n\nCopyright (c) 2017-2024 Guilherme Andrade\n\nPermission is hereby granted, free of charge, to any person obtaining a\ncopy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be included\nin all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS\nOR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\nIN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY\nCLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,\nTORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE\nSOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n\n`locus` is an independent project and has not been authorized,\nsponsored, or otherwise approved by MaxMind.\n\n#","ref":"readme.html#license"},{"type":"extras","title":"Alternative Providers - locus","doc":"- [IPinfo](https://ipinfo.io/) MMDB databases are compatible with `locus`\n    **[since version 2.3.8](https://github.com/g-andrade/locus/issues/44)**\n  - [DB-IP.com](https://db-ip.com/db/): lite databases seem to work but\n    setting up auto-update for them is not practical, as there's no\n    \"latest\" official URL.\n\n#","ref":"readme.html#alternative-providers"},{"type":"extras","title":"Alternative Libraries (Erlang) - locus","doc":"- [egeoip](https://github.com/mochi/egeoip): IP Geolocation module,\n    currently supporting the MaxMind GeoLite City Database\n  - [geodata2](https://github.com/brigadier/geodata2): Application for\n    working with MaxMind geoip2 (.mmdb) databases\n  - [geoip](https://github.com/manifest/geoip): Returns the location of\n    an IP address; based on the ipinfodb.com web service\n  - [geolite2data](https://hex.pm/packages/geolite2data): Periodically\n    fetches the free MaxMind GeoLite2 databases\n  - [ip2location-erlang](https://github.com/ip2location/ip2location-erlang):\n    Uses IP2Location geolocation database\n\n#","ref":"readme.html#alternative-libraries-erlang"},{"type":"extras","title":"Alternative Libraries (Elixir) - locus","doc":"- [asn](https://hex.pm/packages/asn): IP-to-AS-to-ASname lookup\n  - [freegeoip](https://hex.pm/packages/freegeoip): Simple wrapper for\n    freegeoip.net HTTP API\n  - [freegeoipx](https://hex.pm/packages/freegeoipx): API Client for\n    freegeoip.net\n  - [geoip](https://hex.pm/packages/geoip): Lookup the geo location for\n    a given IP address, hostname or Plug.Conn instance\n  - [geolix](https://hex.pm/packages/geolix): MaxMind GeoIP2 database\n    reader/decoder\n  - [plug\\_geoip2](https://hex.pm/packages/plug_geoip2): Adds geo\n    location to a Plug connection based upon the client IP address by\n    using MaxMind's GeoIP2 database\n  - [tz\\_world](https://hex.pm/packages/tz_world): Resolve timezones\n    rom a location efficiently using PostGIS and Ecto","ref":"readme.html#alternative-libraries-elixir"},{"type":"extras","title":"Changelog","doc":"# Changelog\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](http://keepachangelog.com/en/1.0.0/)\nand this project adheres to [Semantic Versioning](http://semver.org/spec/v2.0.0.html).\n\n## [2.3.10] - 2024-07-24\n\n#","ref":"changelog.html"},{"type":"extras","title":"Fixed - Changelog","doc":"- use of binary string in `database_cache_file` option\n\n## [2.3.9] - 2024-07-20\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Elixir-specific info to README (thanks https://github.com/petrus-jvrensburg)\n- OTP 27.0 to CI\n\n## [2.3.8] - 2024-05-04\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- wrong root in MMDB tree parser, failing IPv4 lookups in IPv6 databases that\n  don't include IPv4-mapped IPv6 addresses [wrong since 1.0.0]\n\n## [2.3.7] - 2024-03-16\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- OTP 25.3 to CI\n- OTP 26.0 to CI\n- OTP 26.1 to CI\n- OTP 26.2 to CI\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- README\n- CI to use latest rebar3 version that's compatible with each covered OTP release\n\n## [2.3.6] - 2022-09-20\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- failed load of .tgz database when its mime type is listed as \"application/x-tar\"\n\n## [2.3.5] - 2022-09-20\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- broken CLI check when loading database from a HTTP(S) URL\n\n## [2.3.4] - 2022-09-12\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- broken compilation under Elixir's Mix (introduced in 2.3.3)\n\n## [2.3.3] - 2022-09-12\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- unwarranted compilation warning on OTP 25\n\n## [2.3.2] - 2022-08-07\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- OTP 25 to CI\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- a few wrong specs\n- `rebar3_lint` warnings on OTP 25\n- `rebar3_hank` warnings on OTP 25\n- Dialyzer warnings on OTP 25\n- a few eqWAlizer warnings\n\n## [2.3.1] - 2022-04-19\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- spelling mistakes in CHANGELOG [Kian-Meng Ang]\n\n## [2.3.0] - 2022-01-25\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- the ability to customize database cache path [Bartosz Szafran]\n\n## [2.2.2] - 2021-12-01\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- wrong reference to custom database fetcher in README [Bartosz Szafran]\n\n## [2.2.1] - 2021-09-22\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- decoding of negative integers [made wrong in 2.0.0]\n\n## [2.2.0] - 2021-09-03\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- documentation from edoc to ExDoc\n- imported version of `tls_certificate_check` to '~> 1.9'\n\n## [2.1.0] - 2021-08-30\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- `locus_mmdb:unpack_tree_data_and_data_section/2` to the API\n- `locus_mmdb_data_codec:parse_on_index/3` to the API\n- CI on Windows\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Removed - Changelog","doc":"- no longer warranted run time dependency (`public_key`)\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Fixed - Changelog","doc":"- wrong return of errors during `:check/1` for maps containing maps or arrays\nwhich had been checked previously\n- wrong paths in `:check/1` errors or warnings concerning maps\n- no longer warranted type definition\n\n## [2.0.0] - 2021-08-30\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- support for retrieving databases using consumer-defined `locus_custom_fetcher`s\n- support for decoding IEEE-754 infinities in MMDB data\n- `locus:check/1` to API (which replaces `locus:analyze/1` and can be up to *3200% faster* 🏎️)\n- details to MMDB unpacking errors\n- linting checks with `rebar3_lint`\n- dead code checks with `rebar3_hank`\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- ⚠️ **return type of `locus:lookup/2`** (see MIGRATION.md)\n- database loader to use `persistent_term` instead of ETS\n- MMDB decoder to perform stricter metadata validations\n- MMDB decoder to not crash upon maps containing duplicate keys\n- databases downloaded through HTTP(S) without a `last-modified` response header to no longer\nbe cached\n- imported version of `tls_certificate_check` to '~> 1.7'\n- single CT suite covering both filesystem and HTTP sources into one for each\n- test coverage for the better\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"- ⚠️ **`locus:wait_for_loader/1` from API** (deprecated in 1.10.0 - see MIGRATION.md)\n- ⚠️ **`locus:wait_for_loader/2` from API** (deprecated in 1.10.0 - see MIGRATION.md)\n- ⚠️ **`locus:wait_for_loaders/2` from API** (deprecated in 1.10.0 - see MIGRATION.md)\n- ⚠️ **`locus:get_version/1` from API** (deprecated in 1.4.0 - see MIGRATION.md)\n- ⚠️ **`locus:analyze/1` from API** (`locus:check/1` now fulfills this role - see MIGRATION.md)\n- **deprecated loader options** `pre_readiness_update_period` and `post_readiness_update_period`\n(see MIGRATION.md)\n- warnings on the use of discontinued GeoLite2 HTTP URLs\n\n## [1.16.1] - 2021-07-12\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Fixed - Changelog","doc":"- erroneous decoding of 32-bit signed integers as signed when they're less than 4 bytes in length\n- small risk of API functions `:await_loader` and `:await_loaders` blocking indefinitely longer\nthan they should\n\n## [1.16.0] - 2021-05-13\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- OTP 24 to CI targets\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- minimum Erlang/OTP version to 22\n- imported version of `tls_certificate_check` to '~> 1.5'\n\n## [1.15.0] - 2021-04-02\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- imported version of `tls_certificate_check` to '~> 1.3'\n- minimum Erlang/OTP version to 21.2\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"- `stacktrace_compat` dependency\n- (now-)dead code that dealt with pre- OTP 21.2 differences in `stdlib` and such\n- unmaintained compatibility with rebar 2\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Fixed - Changelog","doc":"- import of MaxMind test data in a way that works both locally and on GHA\n\n## [1.14.1] - 2021-03-16\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Hex documentation\n\n## [1.14.0] - 2021-03-12\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- imported version of `tls_certificate_check` to 1.2.0\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- broken `tls_certificate_check`s when using rebar3 3.14.4\n\n## [1.13.2] - 2020-12-10\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- CI from Travis to GitHub actions\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- documentation unavailability in hexdocs.pm (hopefully)\n\n## [1.13.1] - 2020-12-08\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- `tls_certificate_check` compilation errors on OTP 20.1+, when on top of macOS Big Sur\n\n## [1.13.0] - 2020-12-05\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- CA bundles, based on the latest mkcert.org full CA list as of Nov 13, 2020\n- imported `stacktrace_compat` version to benefit from its latest improvements\n\n## [1.12.2] - 2020-10-29\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- erroneous execution of the optional \"remote HTTP\" test group when a license key is lacking\n\n## [1.12.1] - 2020-10-16\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- misdetection of Mix as being rebar 2 and the erroneous compilation warnings that followed it\n\n## [1.12.0] - 2020-05-21\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- support for OTP 23\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- checksum verification algorithm of MaxMind downloads from MD5 to SHA-256\n\n## [1.11.0] - 2020-05-11\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- support for HTTPS redirections across distinct hostnames\n- support for not censoring license keys from MaxMind URLs mentioned in logs\n- support for censorship of arbitrary query arguments from HTTP URLs mentioned in logs\n- truncation of large HTTP URLs mentioned in logs\n- `download_redirected` events to HTTP downloads\n- `too_many_redirections` and `invalid_redirection` reasons to HTTP download failures\n- mention of compatibility with other providers\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- consumer-subscribed events as to follow the same URL censorship rules as the built-in logger\n- documented MaxMind database edition format from atoms to tuples while keeping retrocompatibility\n\n## [1.10.2] - 2020-03-13\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- unmaintained compatibility with rebar 2\n\n## [1.10.1] - 2020-03-11\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- CA bundles, based on the latest Mozilla Included CA Certificate List [Paulo Oliveira]\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- misformatted log warning\n- use of deprecated function in README example of how to use the library\n- display of private function in generated function reference\n\n## [1.10.0] - 2020-02-12\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- `:await_loader` API function which, contrary to `:wait_for_loader`, will await readiness\nup to the entire specified interval (rather than return upon the first encountered failure)\n- checksum verification of databases downloaded directly from MaxMind\n- rejection of successful HTTP downloads if body size doesn't match `content-length`\n- censorship of license key from database URLs mentioned in logs\n- purging of very large binaries from internally caught exceptions which are known error cases,\nas to lower the risk of the VM getting OOM-killed when logging formatters get their hands\non those very large chunks of data\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- default behaviour upon failing to load a database, as to retry loading while exponentially backing off\n(using very short intervals at first)\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Deprecated - Changelog","doc":"- `:wait_for_loader` and `:wait_for_loaders` API functions (use `:await_loader` and `:await_loaders`\ninstead)\n\n#","ref":"changelog.html#deprecated"},{"type":"extras","title":"Fixed - Changelog","doc":"- incomplete spec for `locus_loader:event()` type\n- wrong spec for `locus_maxmind_download:msg()` and `locus_maxmind_download:event()` types\n\n## [1.9.0] - 2020-02-03\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- documentation as to reflect the recent changes to MaxMind licensing requirements\n\n## [1.9.0-beta] - 2020-01-02\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- support for loading databases with full awareness of license keys (now mandatory)\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Deprecated - Changelog","doc":"- the use of discontinued \"https://geolite.maxmind.com/download/geoip/database/GeoLite2-...\" database URLs\n\n## [1.8.0] - 2019-11-05\n\n#","ref":"changelog.html#deprecated"},{"type":"extras","title":"Added - Changelog","doc":"- support for returning types other than map upon successful lookups\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- MMDB decoder, which was split into separate tree, data section and analysis modules\n- imported `stacktrace_compat` version [1.0.2 => 1.1.1]\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"- support for OTP 18\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Fixed - Changelog","doc":"- incidents of `locus` managerial processes keeping references to old binaries, upon a database update,\n  for a potentially unlimited time (OTP 20+ only)\n- broken logging of playground shell on OTP 21.1+\n\n## [1.7.0] - 2019-08-12\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- ability of loading databases from uncompressed tarballs (`.tar` files)\n- ability of loading unpacked databases (`.mmdb` and `.mmdb.gz` files)\n- stacktrace of caught exceptions to event reporting (including custom logger)\n- ability of launching database loaders under library consumers' own supervisors\n- `wait_for_loaders/2` API method for concurrently awaiting multiple database loaders\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- log level of HTTP and filesystem database loading failures from warning to error\n- HTTP and filesystem loaders into a common loader codebase\n- caching of HTTP databases as to store and load compressed `.mmdb` files rather than tarballs\n- supervision structure as to launch database loaders as transient processes under a new `simple_one_for_one` supervisor\n- dependency versions:\n    - `certifi` [2.4.2 => 2.5.1]\n    - `ssl_verify_fun` [1.1.4 => 1.1.5]\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"- support for OTP 17.4 and 17.5\n- undocumented support for rebar 2\n- half-baked and unwarranted support for `file://`-prefixed URLs\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Fixed - Changelog","doc":"- case-sensitive patterning of `.mmdb` file extensions within tarballs\n- overly verbose `logger` messages on OTP 21.1+\n- HTTPS certificate validation test cases on OTP 22\n\n## [1.6.2] - 2019-03-16\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Dialyzer warning on OTP 21.3\n\n## [1.6.1] - 2019-02-04\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- crash in HTTP loader when database URL scheme is not in lower case\n  (introduced in 1.6.0)\n\n## [1.6.0] - 2019-01-27\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- new API method for validating loaded databases (`locus:analyze/1`)\n- new command line tool supporting database validation\n- new dependencies:\n    - `certifi` 2.4.2\n    - `ssl_verify_fun` 1.1.4\n    - `stacktrace_transform` 1.0.2\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- test coverage using MaxMind's test data was greatly extended\n- database decoder was thoroughly optimized\n- documentation was mildly improved\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- misguided rejection of UTF-8 strings with non-printable (but valid) codepoints\n- unnecessarily strict refusal to load 2.x database formats succeeding 2.0\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Security - Changelog","doc":"- safety of database HTTPS downloads was substantially improved by now\n  rejecting expired certificates, mismatched hostnames, self-signed\n  certificates or unknown certificate authorities\n- infinite recursion in maliciously crafted databases due to\n  circular paths is now prevented\n\n## [1.5.1] - 2019-01-19\n\n#","ref":"changelog.html#security"},{"type":"extras","title":"Fixed - Changelog","doc":"- unwarranted import of rebar3_hex plugin in library consumers\n\n## [1.5.0] - 2018-11-25\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- ability of tweaking pre- and post-readiness database update periods\n- test coverage of HTTP-loaded database updates\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- undeterministic test cases which sometimes broke\n\n## [1.4.0] - 2018-06-20\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- official test cases for good data at https://github.com/maxmind/MaxMind-DB/\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- string and binary IP address parsing to handle ranges and shortened addresses\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Deprecated - Changelog","doc":"- :get_version/1 (use :get_info/2)\n\n## [1.3.1] - 2018-05-04\n\n#","ref":"changelog.html#deprecated"},{"type":"extras","title":"Fixed - Changelog","doc":"- incompatibility with OTP 20.3.1 due to gen_statem bug (issue with init actions)\n\n## [1.2.3] - 2018-05-04\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- incompatibility with OTP 20.3.1 due to gen_statem bug (issue with init actions)\n\n## [1.1.5] - 2018-05-04\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- incompatibility with OTP 20.3.1 due to gen_statem bug (issue with init actions)\n\n## [1.0.2] - 2018-05-04\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- incompatibility with OTP 20.3.1 due to gen_statem bug (issue with init actions)\n\n## [1.3.0] - 2018-03-28\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- ability of loading databases from local file system\n- type spec of database entries\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- wrong handling of timezones on cached tarballs\n- wrong handling of daylight saving time on conditional HTTP requests\n\n## [1.2.2] - 2018-03-28\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- wrong handling of timezones on cached tarballs\n- wrong handling of daylight saving time on conditional HTTP requests\n\n## [1.1.4] - 2018-03-28\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- wrong handling of timezones on cached tarballs\n- wrong handling of daylight saving time on conditional HTTP requests\n\n## [1.0.1] - 2018-03-28\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- wrong handling of timezones on cached tarballs\n- wrong handling of daylight saving time on conditional HTTP requests\n\n## [1.2.1] - 2018-02-15\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- undesirable inlining\n\n## [1.2.0] - 2018-02-15\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- OTP 17.4 and 17.5 support\n\n## [1.1.3] - 2018-02-13\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- matched IP address prefix not being returned on successful lookups\n\n## [1.1.2] - 2018-02-13\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- documentation external links not opening in parent frame\n\n## [1.1.1] - 2018-02-12\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- internal functions showing up as public in documentation\n- documented description of `locus_logger:set_loglevel/2`\n\n## [1.1.0] - 2018-02-11\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- OTP 18 support\n- OTP 19.0, 19.1 and 19.2 support\n- ability of consulting database metadata, source and version through `:get_info`\n- ability of subscribing database loader events\n- ability of specifying connect, download start and idle download timeouts\n- ability of turning off cache\n\n## [1.0.0] - 2017-12-31\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- ability of downloading .mmdb databases using HTTP\n- ability of querying those databases\n- ability of caching said databases on the local filesystem\n- ability of conditioning said downloads based on cache content and 'if-modified-since' headers\n- ability of regularly performing database update attempts\n- OTP 19.3 and 20.x for all of the above","ref":"changelog.html#added"},{"type":"extras","title":"Migration guide","doc":"# Migration guide\n\nWhenever there's an interface breaking change (a change in the project's major version),\nrequired migration instructions will be detailed in this file.","ref":"migration.html"},{"type":"extras","title":"From [1.x] to [2.x] - Migration guide","doc":"#","ref":"migration.html#from-1-x-to-2-x"},{"type":"extras","title":"Update - Migration guide","doc":"- any code matching the return of `locus:lookup/2` to match `not_found` rather than\n`{error, not_found}`:\n\n```erlang\n% before:\ncase locus:lookup(country, \"93.184.216.34\") of\n    {ok, #{<<\"country\">> := #{<<\"iso_code\">> := Country}}} ->\n        % [...]\n    {error, not_found} ->\n        % [...]\nend.\n\n% after:\ncase locus:lookup(country, \"93.184.216.34\") of\n    {ok, #{<<\"country\">> := #{<<\"iso_code\">> := Country}}} ->\n        % [...]\n    not_found ->\n        % [...]\nend.\n```\n\n- calls to `wait_for_loader/1` to invoke `await_loader/1` instead:\n\n```erlang\n% before\ncase locus:wait_for_loader(country) of\n    {ok, _LoadedVersion} ->\n        % [...]\n    {error, {loading, LoadAttemptFailure}} ->\n        % [...]\nend.\n\n% after\ncase locus:await_loader(country) of\n    {ok, _LoadedVersion} ->\n        % [...]\n    {error, {timeout, LoadAttemptFailures}} ->\n        % Notice how `LoadAttemptFailures' is a list\n        % [...]\nend.\n```\n\n- calls to `wait_for_loader/2` to invoke `await_loader/2` instead:\n\n```erlang\n% before\ncase locus:wait_for_loader(country, _Timeout = 30000) of\n    {ok, _LoadedVersion} ->\n        % [...]\n    {error, {loading, LoadAttemptFailure}} ->\n        % [...]\n    {error, timeout} ->\n        % [...]\nend.\n\n% after\ncase locus:await_loader(country, _Timeout = 30000) of\n    {ok, _LoadedVersion} ->\n        % [...]\n    {error, {timeout, LoadAttemptFailures}} ->\n        % Notice how `LoadAttemptFailures' is a list\n        % and there's no longer a separate return type for `timeout`\n        % [...]\nend.\n```\n\n- calls to `wait_for_loaders/2` to invoke `await_loaders/2` instead:\n\n```erlang\n% before\ncase locus:wait_for_loaders([country, asn], _Timeout = 30000) of\n    {ok, _LoadedVersionPerDatabase} ->\n        % [...]\n    {error, {DatabaseId, LoaderFailure}} ->\n        % [...]\n    {error, timeout} ->\n        % [...]\nend.\n\n% after\ncase locus:await_loaders([country, asn], _Timeout = 30000) of\n    {ok, _LoadedVersionPerDatabase} ->\n        % [...]\n    {error, ErrorPerDatabase, PartialSuccesses} ->\n        % Notice how `ErrorPerDatabase' and `PartialSuccesses' are maps\n        % and there's no longer a separate return type for `timeout`\n        % [...]\nend.\n```\n\n- calls to `get_version/1` to invoke `get_info/2` instead:\n\n```erlang\n% before\n{ok, LoadedVersion} = locus:get_version(country),\n\n% after\n{ok, LoadedVersion} = locus:get_info(country, version),\n```\n\n- any use of the `{pre_readiness_update_period, Interval}` loader option,\nif exponential backoff (the default for some time) is not to your liking:\n\n```erlang\n% before\n{pre_readiness_update_period, Interval}\n\n% after\n{error_retries, {backoff, Interval}}\n```\n\n- any use of the `{post_readiness_update_period, Interval}` loader option:\n\n```erlang\n% before\n{post_readiness_update_period, Interval}\n\n% after\n{update_period, Interval}\n```\n\n- any code matching/using `metadata`, whether through `locus:get_info/1` or `locus:get_info/2`,\nto use atom keys instead of binary ones:\n\n```erlang\n% before:\n{ok, Metadata} = locus:get_info(country, metadata),\n#{<<\"binary_format_major_version\">> := Major,\n  <<\"binary_format_minor_version\">> := Minor,\n  <<\"node_count\">> := _,\n  <<\"record_size\">> := _,\n  <<\"ip_version\">> := _,\n  <<\"database_type\">> := _,\n  <<\"languages\">> := _,\n  <<\"build_epoch\">> := _,\n  <<\"description\">> := _} = Metadata,\n\n% after:\n{ok, Metadata} = locus:get_info(country, metadata),\n#{binary_format_version := {Major, Minor}, % Notice how this was two keys before\n  node_count := _,\n  record_size := _,\n  ip_version := _,\n  database_type := _,\n  languages := _,\n  build_epoch := _,\n  description := _} = Metadata,\n```\n\n- any code calling and matching the return of `locus:analyze/1` with one\nto `locus:check/1` (the semantics of the return type are wildly different;\nconsult the API reference for details)\n\n#","ref":"migration.html#update"},{"type":"extras","title":"Remove - Migration guide","doc":"- your code matching or making use of `prefix` for a successful `locus:lookup/2`, e.g.\n\n```erlang\n% `prefix' is gone (open an issue if you'd like to see it back)\n{ok, #{prefix := _}} = locus:lookup(country, \"94.186.216.34\")\n```","ref":"migration.html#remove"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2017-2024 Guilherme Andrade\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}